

module acq_uart_cmd(
	Clk,
	Rst_n,
	
	rx_data,
	rx_done,
	adc_din,
	acq_num,
	switch,
	led
);


	input Clk;
	input Rst_n;
	input [7:0]rx_data;  //串口接收数据
	input rx_done;
	output reg led;
	
	output reg [7:0]adc_din;  //通道
	output reg [7:0]acq_num;  //接收计数
	output reg [7:0]switch;  //开关
	//reg [7:0]data_str;
	//移位接收串口数据
	reg [7:0]data_str[5:0];  //8个8位的数据
	//reg rx_done;
	reg rx_done_r;
	reg [3:0]switch_cnt;
	
	always@(posedge Clk)
	if(rx_done)begin  //移位操作
		data_str[5] <= rx_data;
		data_str[4] <= data_str[5];
		data_str[3] <= data_str[4];
		data_str[2] <= data_str[3];
		data_str[1] <= data_str[2];
		data_str[0] <= data_str[1];
	end
		
	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)
		rx_done_r <= 1'd0;
	else 
		rx_done_r <= rx_done;
		
	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)begin
		adc_din <= 8'd0;
		acq_num <= 8'd100;
		switch <= 8'd0;
		led <= 1'd1;
	end	
	else if(rx_done_r)begin
		if((data_str[0] == 8'h55) && (data_str[1] == 8'h5a) && (data_str[5] == 8'hf0))begin
			adc_din <= data_str[4]; //通道选择
			acq_num <= data_str[3];  //采样数量选择（fifo设置深度128 若超过还需更改fifo深度）
			switch <= data_str[2];  //采样开关
			led <= ~led;
		end
	end
	else if(switch_cnt == 4'd10)
			switch <= 8'd0;

	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)begin
		switch_cnt <= 4'd0;
	end
	else if(switch_cnt == 4'd10)
		switch_cnt <= 4'd0;
	else 
		switch_cnt <= switch_cnt + 1'd1;
//	else
//		switch_cnt <= switch_cnt;

	
endmodule 

	
		
		
		
		