`timescale 1ns/1ps
`define clk_period 20

module myfifo_tb();

	reg	  Clk;
	reg	[11:0]  data;
	reg	  rdreq;
	reg	  sclr;
	reg	  wrreq;
	
	wire	  almost_empty;
	wire	  almost_full;
	wire	  empty;
	wire	  full;
	wire	[11:0]  q;
	wire	[6:0]  usedw;
	
	myfifo myfifo(
		.clock(Clk),
		.data(data),
		.rdreq(rdreq),
		.sclr(sclr),
		.wrreq(wrreq),
		.almost_empty(almost_empty),
		.almost_full(almost_full),
		.empty(empty),
		.full(full),
		.q(q),
		.usedw(usedw)
	);

	initial Clk = 1;
	always #(`clk_period/2)Clk = ~Clk;
	
	integer i;
	
	initial begin
		wrreq = 1'b0;
		data = 1'b0;
		rdreq = 1'b0;
		sclr = 1'b0;
		#(`clk_period);
		
		
		for(i=0;i<128;i=i+1)begin
			wrreq = 1'b1;  //写使能
			data = i;
		#(`clk_period);
		end
		wrreq = 1'b0;
		
		for(i=0;i<128;i=i+1)begin
			rdreq = 1'b1;
			#`clk_period;
		end
		
		rdreq = 0;
		$stop;
	end
	
endmodule	

		