/*************************************************************
*
*  模块名 ：data_acq
*  日期	：2021年3月4日
*  说明	：数据采集传输系统仿真测试文件
*
****************************************************************/
`timescale 1ns/1ps
`define clk_period 20
`define sin_data_file "./sin_12bit.txt"

module data_acq_tb();

	reg Clk;
	reg Rst_n;
	reg DOUT;  //adc芯片输出的数据
	reg START;
	
	wire Key_in;  //按键输入
	
	reg [11:0]memory[4095:0];  //测试波形数据存储空间
	reg [11:0]addr;  //存储地址
	reg press0;
	
	wire cs;
	wire sclk_o;
	wire DIN;
	wire RE_DONE;
	wire full;
	wire Rs232_Tx;
	
	reg [7:0]tx_data;
	reg send_en;
	wire Rs232_Tx_1;
	wire Tx_Done;
	wire uart_state;
	
	data_acq data_acq(
		.Clk(Clk),
		.Rst_n(Rst_n),
		.DOUT(1'd1),
		
		.cs(cs),
		.sclk_o(sclk_o),
		.DIN(DIN),
		.Key_in(Key_in),
		.Rs232_Tx(Rs232_Tx),
		//.RE_DONE(RE_DONE),
		//.full(full),
		.dac_cs_n(),
		.dac_din(),
		.dac_sclk(),
		.Rs232_Rx(Rs232_Tx_1)
	);	
		
	
	key_model key_model0(
		.press(press0),
		.key(Key_in)
	);
	

	uart_byte_tx uart_byte_tx(
		.Clk(Clk),
		.Rst_n(Rst_n),
		.data_byte(tx_data),
		.send_en(send_en),
		.baud_set(3'd4),
		
		.Rs232_Tx(Rs232_Tx_1),
		.Tx_Done(Tx_Done),
		.uart_state(uart_state)
	);
	
	initial Clk = 1'b1;
	always #(`clk_period/2) Clk = ~Clk;
	
	initial $readmemh(`sin_data_file,memory);
	
	integer i;
	
	initial begin
		Rst_n = 1'd0;
		//DIN_R_IN = 3'd0;
		DOUT = 16'd0;
		START = 0;
		addr = 12'd0;
		press0 = 0;
		send_en = 1'd0;
		tx_data = 0;
		#101;
		Rst_n = 1;
		#100;
		//DIN_R_IN = 3'd5;
		//产生一次按键按下
		//按下之前产生指令
		tx_data <= 8'h55;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'h5a;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'h11;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'h64;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'd05;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'hf0;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		press0 = 1;
		#(`clk_period*3)
		press0 = 0;
		
		@(posedge Tx_Done)
		#80_000_000;
		
		
		
		
		tx_data <= 8'h55;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'h5a;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'h11;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'h64;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'd05;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
		tx_data <= 8'hf0;
		send_en = 1'd1;
		#100;
		send_en = 1'd0;
		@(posedge Tx_Done);
		
//		for(i=0;i<3;i=i+1)begin
//			for(addr=2;addr<4095;addr=addr+1)begin
//				START = 1;
//				#20;
//				START = 0;
//				gene_DOUT(memory[addr]);
//				@(RE_DONE)
//				#200;
//			end
//		end
//		#2000;
		$stop;
	end		
//		
//	task gene_DOUT;
//		input [15:0]vdata;
//		reg [4:0]cnt;
//		begin
//			cnt = 0;
//			wait(!cs);
//			while(cnt<16)begin
//				@(negedge sclk_o) DOUT = vdata[15-cnt];
//				cnt = cnt + 1'b1;
//			end
//		end
//	endtask


	



endmodule 
	